#!/usr/bin/perl

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#   changelog:	
#		2007-10-20	initial release
#		2007-10-20	added avi/mp3-support
#		2007-10-20	changed code for command switches	
#				added renaming-support
#		2007-10-28	added support for myvideo & stage6
#		2007-10-29	added support for changing the videopath 
#				fixed some bugs
#

use strict;
#use warnings;
use utf8;
my %INFO = (
	authors => "Haui",
	contact => "haui45\@web.de",
	date	=> "2007-10-29",
	version => "v0.3a",
	license => "GPL",
	name	=> "ydl - youtube downloader",
);
#****************************************
my $videopath = "/my/videopath/";	#IMPORTANT - change to your path!
#****************************************
my $vidid = "";		#the "url-id"
my $id = "";		#the "magic-id"
my @swfargs;
my $line = "http://youtube.com/get_video?video_id=" ;
my $command;		
my $url = "";
my $dec = "";
my $title = "" ;
my $path = "";
my $encode = 0;		#Zieldatei
my $source = "";
my $name = "";
my @argv;		#ich will nicht an ARGV rumpfuschen
my %options = (
		rename	=> '0',
		help	=> '0',
		sound	=> '0',
		version	=> '0',
		encode	=> '0',
);

sub checkargs(){
	if ($#ARGV +1 == 0){
		print "Keine Elmente\n";
		exit;
	}
	@argv = @ARGV;
	my $i = 0;
	my $return =0;
	while($i <= $#argv){
		if (substr($argv[$i], 0, 1) eq "-"){
			if (substr($argv[$i], 1, 1) eq "-"){
				if (($return=longoptions($argv[$i], $i)) == -1){
					print "Unsupported option!\n";
					exit 1;
				}
				if ($return == 5){
					splice(@argv, $i, 2);
					redo;
				}
				splice(@argv, $i, 1);
				redo;
			}
			else {
				if ((shortoptions($argv[$i], $i)) == -1){
					print "Unsupported option!\n";
					exit 1;
				}
				if ($return == 5){
					splice(@argv, $i, 2);
					redo;
				}
				splice(@argv, $i, 1);
				redo;
			}
		}
		$i++;
	}

	if ($options{'version'} == 1){
		version();
		$options{'version'} = 0;
	}
	if ($options{'help'} == 1){
		help();
		$options{'help'} = 0;
	}
	if ($#argv +1 == 0){
		exit;
	}
	if ($videopath =~ m/\/my\/videopath\//){
		print "Please set a proper videopath!\n";
		exit;
	}
	#print "@{[ %options ]}\n";
}

sub longoptions(){
	my $option = shift;
	my $count = shift;
	$option =~ s/^--//;
	if ($option eq "rename"){
		$options{'rename'} = 1;
		return 0;
	}
	if ($option eq "encode"){
		$options{'encode'} = 1;
		return 0;
	}
	if ($option eq "version"){
		$options{'version'} = 1;
		return 0;
	}
	if ($option eq "help"){
		$options{'help'} = 1;
		return 0;
	}
	if ($option eq "sound"){
		$options{'sound'} = 1;
		return 0;
	}
	if ($option eq "path"){
		$videopath = $argv[$count+1];
		return 5;
	}
	else {
		return -1;
	}
}

sub shortoptions(){
	my $l = 0;
	my $option = shift;
	my $count = shift;
	my $ret = 0;
	$option =~ s/^-//;
	while ($l<length($option)){

		if (substr($option, $l, 1) eq "r"){
			$options{'rename'} = 1;
			$l++;
			next;
		}
		if (substr($option, $l, 1) eq "e"){
			$options{'encode'} = 1;
			$l++;
			next;
		}
		if (substr($option, $l, 1) eq "v"){
			$options{'version'} = 1;
			$l++;
			next;
		}
		if (substr($option, $l, 1) eq "h"){
			$options{'help'} = 1;
			$l++;
			next;
		}
		if (substr($option, $l, 1) eq "s"){
			$options{'sound'} = 1;
			$l++;
			next;
		}
		if (substr($option, $l, 1) eq "p"){
			$videopath = $argv[$count+1];
			$ret = 5 ;
			$l++;
			next;
		}
		else {
			return -1;
		}
	}
	return $ret;
}



sub choose(){
	print "\nWichtig: Wurden alles Links in Anführungszeichen gesetzt? -> \"http://www.youtube.com...\"\n";
	print "[y/n]\n";
	$dec = <STDIN>;
	unless ($dec eq "y\n" or $dec eq "yes\n"){
		exit 1;
	}
	foreach (@argv){
		if (($_ =~ m/^http:\/\/www.youtube.com\/watch/ || $_ =~ m/^http:\/\/youtube.com\/watch/)){
			youtube($_);
			next;
		}
		elsif (($_ =~ m/^http:\/\/www.myvideo.de\/watch/ || $_ =~ m/^http:\/\/myvideo.de\/watch/)){
			myvideo($_);
			next;
		}
		elsif (($_ =~ m/^http:\/\/stage6.divx.com/)){
			stage6($_);
			next;
		}
		else{
			print "$_: Not a valid Link!\n";
			next;
		}
	}
}
sub youtube(){
		my $path = "";
		$vidid = shift;
		$vidid =~ s#http://##;
		$vidid =~ s#www\.##;
		$vidid =~ s#youtube.com/watch\?v=##;
		$vidid =~ s#\&.*##;
		$path = "$videopath" . "/$vidid" . ".flv";
		my @array = `curl \"$_\"`; 	#get link
		if (!($array[0])){
			print "Holen fehlgeschlagen!\n";
			 exit 1;
		}
		@swfargs= grep (/var swfArgs/, @array);	# grep the line
		$id=$swfargs[0];
		undef (@array);
		undef (@swfargs);
		
		$id =~ s/^.*,t:'//;		#alles vor und inkl. ",t:'" loeschen
		$id =~ s/',sk:.*//;		#alles nach und inkl. ,sk: loeschen
		$url = $line . $vidid . "\&t=" . $id;	# url zusammenfuegen

		system (" wget -O \"$path\" \"$url\"") ;
		print "\n[***************]Saved file $path [***************]\n\n";

		if($options{'encode'} == 1){
			if (encode("$path") == -1){
				print "Fehler beim kodieren!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if($options{'sound'} == 1){
			if (sound("$path") == -1){
				print "Fehler beim rippen!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if ($options{'sound'} == 1 || $options{'encode'} == 1 ){
			unlink("$path");
		}
		else{
			if ($options{'rename'} == 1){
				print "\nBitte geben sie einen neuen Dateinamen ein\n";
				$name = <STDIN>;
				chomp($name);
				$name = "$videopath" . "/$name";
				rename("$path", "$name");
				print "\n$path erfolgreich nach $name umbenannt!\n\n";
		}
		$path="";
		}
	}
sub myvideo(){
		my $path = "";
		$vidid = shift;
		print "$vidid\n\n\n\n";
		my @array = `curl \"$vidid\"`;	 	#get link
		if (!($array[0])){
			print "Holen fehlgeschlagen!\n";
			exit 1;
		}

		$vidid =~ s#http://##;			#
		$vidid =~ s#www\.##;			# url-id bekommen
		$vidid =~ s#myvideo\.de/watch/##;	# funktionieren sollen
		print "$vidid\n";

		$path = "$videopath" . "/$vidid" . ".flv";

		@swfargs = grep (/myvideo-[0-9]*\.[a-z]*\.llnwd\.net\/.*\/thumbs\/$vidid.*\.jpg/, @array);
		$id=$swfargs[0];
		undef (@array);
		undef (@swfargs);
		$id =~ s#.*id='[a-z]$vidid' src='##;
		$id =~ s#thumbs/$vidid.*\.jpg.*##;
		chomp($id);
		$id = $id . $vidid . ".flv";
		chomp($id);
				
		$url = $id;
		system (" wget -O \"$path\" \"$url\"");
		print "\n[***************]Saved file $path [***************]\n\n";

		if($options{'encode'} == 1){
			if (encode("$path") == -1){
				print "Fehler beim kodieren!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if($options{'sound'} == 1){
			if (sound("$path") == -1){
				print "Fehler beim rippen!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if ($options{'sound'} == 1 || $options{'encode'} == 1 ){
			unlink("$path");
		}
		else{
			if ($options{'rename'} == 1){
				print "\nBitte geben sie einen neuen Dateinamen ein\n";
				$name = <STDIN>;
				chomp($name);
				$name = "$videopath" . "/$name";
				rename("$path", "$name") or die "myvideo rename: Something went wrong. Fix it! :)\n";
				print "\n$path erfolgreich nach $name umbenannt!\n\n";
		}
		$path="";
		}
	}


sub stage6(){
		my $path = "";
		$vidid = shift;
		$vidid =~ s#.*video/##;	
		$vidid =~ s#/.*##;
		chomp $vidid;
		print "$vidid\n";
		$url = "http://video.stage6.com/" . $vidid . "/.divx";
		$path = "$videopath" . "/$vidid" . ".avi";

		system (" wget -O \"$path\" \"$url\"");
		print "\n[***************]Saved file $path [***************]\n\n";

		if($options{'encode'} == 1){
			if (encode("$path") == -1){
				print "Fehler beim kodieren!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if($options{'sound'} == 1){
			if (sound("$path") == -1){
				print "Fehler beim rippen!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if ($options{'sound'} == 1 || $options{'encode'} == 1 ){
			unlink("$path");
		}
		else{
			if ($options{'rename'} == 1){
				print "\nBitte geben sie einen neuen Dateinamen ein\n";
				$name = <STDIN>;
				chomp($name);
				$name = "$videopath" . "/$name";
				rename("$path", "$name") or die "stage6 rename: Something went wrong. Fix it! :)\n";
				print "\n$path erfolgreich nach $name umbenannt!\n\n";
		}
		$path="";
		}
	}


sub encode(){
	$source = shift;
	$encode = $source;
	$encode =~ s/\.flv/\.avi/;
	$command = "mencoder \"$source\" -oac mp3lame -lameopts abr:br=92" .
	" -ovc xvid -xvidencopts bitrate=150 -o \"$encode\"";
	#$command = "ffmpeg -i \"$source\" -f avi -vcodec xvid -acodec mp3  -s 320x240 \"$encode\"";
	system("$command") == 0 or return -1;

	if ($options{'rename'} == 1){
		print "\nBitte geben sie einen neuen Dateinamen ein\n";
		$name = <STDIN>;
		chomp($name);
		$name =~ s/.avi$//;
		$name = "$videopath" . "/$name" . ".avi";
		rename("$encode", "$name") or die "encode rename: Something went wrong. Fix it! :)\n";
		print "\n$encode erfolgreich nach $name umbenannt!\n\n";
	}

}

sub sound(){
	$source = shift;
	$encode = $source;
	$encode =~ s/\.flv/\.mp3/;
	$encode =~ s/\.avi$/\.mp3/;
	system("mplayer -dumpaudio -dumpfile \"$encode\" \"$source\"") == 0
			or return -1;
	if ($options{'rename'} == 1){
		print "\nBitte geben sie einen neuen Dateinamen ein\n";
		$name = <STDIN>;
		chomp($name);
		$name =~ s/.mp3$//;
		$name = "$videopath" . "/$name" . ".mp3";
		rename("$encode", "$name") or die "sound rename: Something went wrong. Fix it!\n";
		print "\n$encode erfolgreich nach $name umbenannt!\n\n";
	}
}



sub help(){
	print "Aufruf: ydl.pl \"link1\" \"link2\" ...\n".

	 "\nWichtig: die Links müssen von Anführungszeichen umschlossen sein!\n".
	 "Benötig wget, curl und ggf. mencoder/mplayer \n".
	 "Kommandozeilenargument:\n".
	 "   -e, --encode \t enkodiert alle Videos ins divx-Format. Benötigt mencoder!\n".
	 "    \t\t\t ydl -e \"http://youtube...\"\n".
	 "   -s, --sound\t\t extrahiere nur die Sounddaten. Benötigt mplayer!\n".
	 "    \t\t\t ydl -s \"http://youtube...\"\n".
	 "   -r, --rename \t benennt alle Dateien um\n" .
	 "   -p, --path PFAD \t ändert den Zielordner auf PFAD\n" . 
	 "   -h, --help   \t Zeig diese Hilfe an\n".
	 "   -v, --version \t Print version.\n";
	
	return;
}
sub version(){
	print "ydl - youtube-downloader version $INFO{'version'} - $INFO{'date'}\n";
	print "Author: $INFO{'authors'}, contact $INFO{'contact'}\n";
	return;
}

checkargs();
choose();

